
uniform vec4  xc,yc;         // centers of the blobs 
uniform vec4  r_,q_;         // r[i]^2, 1/r[i]^2, 0-ra kiegeszitve!!
uniform float critical;      // 0..1

varying vec2 v_blob_xy;      // mert a geometriat torzithatjuk kedvunkre

const vec4 one = vec4(1.0);
const vec4 two = vec4(2.0);

// kills the largest component
/*
void kill(inout vec4 v)
{ if ( dot(one,step(v.x,v)) == 1.0 ) v.x=0.0;
  else
  { if ( dot(one,step(v.y,v)) == 1.0 ) v.y=0.0;
    else
    { if ( dot(one,step(v.z,v)) == 1.0 ) v.z=0.0; else v.w=0.0;
    }
  }
} 
*/

// kills the largest component of v, and the same component of w too
void kill2(inout vec4 v, inout vec4 w)
{ if ( dot(one,step(v.x,v)) == 1.0 ) { v.x=0.0; w.x=0.0; }
  else
  { if ( dot(one,step(v.y,v)) == 1.0 ) { v.y=0.0; w.y=0.0; }
    else
    { if ( dot(one,step(v.z,v)) == 1.0 ) { v.z=0.0; w.z=0.0; } else { v.w=0.0; w.w=0.0; }
    }
  }
} 

void main()
{
  vec4 x,y,q,bq,tmp;
  float A,B,C,D;
  float k,w;
    
  x = vec4(v_blob_xy.x) - xc;
  y = vec4(v_blob_xy.y) - yc;
  
  q  = q_;                   // mert valtozhat kesobb
  bq = q * (x*x + y*y);      // nem baj hogy tobb nemnulla komponens van, mindig q-val szorozzuk

  tmp = 1.0 - step(1.0,bq);  // 1.0 where bq<1.0 and 0 where bq>=1.0

  gl_FragColor.rgb = tmp.xyz*0.5; 
  return;

  q  *= tmp;
  bq *= tmp; 
  k   = dot(tmp,tmp);   // !!
  
  gl_FragColor.rgb = vec3( 0.25*k );
  return;
  
  A = dot(q,q);     
  B = dot(q,one) - dot(bq,q);  
  C = k - dot(bq,two) + dot(bq,bq) - critical;
  D = B*B - A*C;
 
  while (D<0.0) 
  { 
    kill2(bq,q);
    k--;
    
    A = dot(q,q);     
    B = dot(q,one) - dot(bq,q);                      // igazibol ez -B/2  
    C = k - dot(bq,two) + dot(bq,bq) - critical;
    D = B*B - A*C;    
  }
  
  w = B - sqrt(D);
  
  if (w<0.0)
  {
    gl_FragColor.rgb = vec3(0.8,0.4,0.6);
    return;
  }
  
  w /= A;
  
  while (any(greaterThan( w*q + bq , one )))
  { 
    kill2(bq,q);
    k--;
    
    A = dot(q,q);     
    B = dot(q,one) - dot(bq,q);                      // igazibol ez -B/2  
    C = k - dot(bq,two) + dot(bq,bq) - critical;
    D = B*B - A*C;    
  
    w = (B - sqrt(D)) / A;
  }
  
  gl_FragColor.rgb = vec3(2.0*sqrt(w));

}


